OpenTTD Source: EndianBufferWriter< Tcont, Titer > Class Template Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes
EndianBufferWriter< Tcont, Titer > Class Template Reference

Endian-aware buffer adapter that always writes values in little endian order. More...

`#include <endian_buffer.hpp>`

## Public Member Functions
| EndianBufferWriter (Titer buffer)
| EndianBufferWriter (typename Titer::container_type &container)
EndianBufferWriter & | operator<< (const std::string &data)
EndianBufferWriter & | operator<< (const char *data)
EndianBufferWriter & | operator<< (std::string_view data)
EndianBufferWriter & | operator<< (bool data)
template<typename T >
EndianBufferWriter & | operator<< (const OverflowSafeInt< T > &data)
template<typename... Targs>
EndianBufferWriter & | operator<< (const std::tuple< Targs... > &data)
template<class T , std::enable_if_t< std::disjunction_v< std::negation< std::is_class< T > >, std::is_base_of< StrongTypedefBase, T > >, int > = 0>
EndianBufferWriter & | operator<< (const T data)

## Static Public Member Functions
template<typename Tvalue , typename Tbuf = std::vector<uint8_t>>
static Tbuf | FromValue (const Tvalue &data)

## Private Member Functions
template<class Ttuple , size_t... Tindices>
void | WriteTuple (const Ttuple &values, std::index_sequence< Tindices... >)
| Helper function to write a tuple to the buffer.
void | Write (std::string_view value)
| Write overload for string values.
template<class T >
void | Write (T value)
| Fundamental write function.

## Private Attributes
Titer | buffer
| Output iterator for the destination buffer.

## Detailed Description

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
class EndianBufferWriter< Tcont, Titer >

Endian-aware buffer adapter that always writes values in little endian order.

Note
  This class uses operator overloading (<<, just like streams) for writing as this allows providing custom operator overloads for more complex types like e.g. structs without needing to modify this class.

Definition at line 26 of file endian_buffer.hpp.

## Constructor & Destructor Documentation

## ◆ EndianBufferWriter() [1/2]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter< Tcont, Titer >::EndianBufferWriter | ( | Titer | buffer | ) |
| inline

Definition at line 31 of file endian_buffer.hpp.

## ◆ EndianBufferWriter() [2/2]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter< Tcont, Titer >::EndianBufferWriter | ( | typename Titer::container_type & | container | ) |
| inline

Definition at line 32 of file endian_buffer.hpp.

## Member Function Documentation

## ◆ FromValue()

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<typename Tvalue , typename Tbuf = std::vector<uint8_t>>

static Tbuf EndianBufferWriter< Tcont, Titer >::FromValue | ( | const Tvalue & | data | ) |
| inlinestatic

Definition at line 63 of file endian_buffer.hpp.

## ◆ operator<<() [1/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | bool | data | ) |
| inline

Definition at line 37 of file endian_buffer.hpp.

## ◆ operator<<() [2/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | const char * | data | ) |
| inline

Definition at line 35 of file endian_buffer.hpp.

## ◆ operator<<() [3/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<typename T >

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | const OverflowSafeInt< T > & | data | ) |
| inline

Definition at line 40 of file endian_buffer.hpp.

## ◆ operator<<() [4/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | const std::string & | data | ) |
| inline

Definition at line 34 of file endian_buffer.hpp.

## ◆ operator<<() [5/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<typename... Targs>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | const std::tuple< Targs... > & | data | ) |
| inline

Definition at line 43 of file endian_buffer.hpp.

## ◆ operator<<() [6/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<class T , std::enable_if_t< std::disjunction_v< std::negation< std::is_class< T > >, std::is_base_of< StrongTypedefBase, T > >, int > = 0>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | const T | data | ) |
| inline

Definition at line 50 of file endian_buffer.hpp.

## ◆ operator<<() [7/7]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

EndianBufferWriter & EndianBufferWriter< Tcont, Titer >::operator<< | ( | std::string_view | data | ) |
| inline

Definition at line 36 of file endian_buffer.hpp.

## ◆ Write() [1/2]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

void EndianBufferWriter< Tcont, Titer >::Write | ( | std::string_view | value | ) |
| inlineprivate

Write overload for string values.

Definition at line 80 of file endian_buffer.hpp.

## ◆ Write() [2/2]

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<class T >

void EndianBufferWriter< Tcont, Titer >::Write | ( | T | value | ) |
| inlineprivate

Fundamental write function.

Definition at line 90 of file endian_buffer.hpp.

References GB().

## ◆ WriteTuple()

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>
template<class Ttuple , size_t... Tindices>

void EndianBufferWriter< Tcont, Titer >::WriteTuple | ( | const Ttuple & | values,
|  | std::index_sequence< Tindices... > |
| ) |  |
| inlineprivate

Helper function to write a tuple to the buffer.

Definition at line 74 of file endian_buffer.hpp.

## Field Documentation

## ◆ buffer

template<typename Tcont = typename std::vector<uint8_t>, typename Titer = typename std::back_insert_iterator<Tcont>>

Titer EndianBufferWriter< Tcont, Titer >::buffer
| private

Output iterator for the destination buffer.

Definition at line 28 of file endian_buffer.hpp.

The documentation for this class was generated from the following file:

- src/misc/endian_buffer.hpp